/*
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an
 * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations
 * under the License.
 */

package npanday.plugin;

import org.w3c.dom.Document;
import org.w3c.dom.Element;
import org.w3c.dom.Node;
import org.apache.maven.plugin.MojoExecutionException;

@ConfigurationAppenderAnnotation( targetClassName = "java.lang.String")
public class StringConfigurationAppender
    implements ConfigurationAppender
{
    public void append( Document document, Element element, FieldInfo fieldInfo )
        throws MojoExecutionException
    {
        Object value = fieldInfo.getValue();
        if ( ! ( value instanceof String ) )
        {
            if ( value != null )
            {
                System.out.println( "CLASS:" + value.getClass().getName() );
                throw new MojoExecutionException( "" );
            }
        }
        else
        {
            Node n1 = document.createElement( fieldInfo.getName());
            n1.setTextContent( (String) fieldInfo.getValue() );
            element.appendChild( n1 );
        }
    }
}
